#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <ctime>
using namespace std;

map<int, set<int> > grp; // gruppide graaf: grupp -> liikmed
vector<int> gg, uu; // kik grupid, kik kasutajad

int main() {
    srand(time(0));
    int n, m, mg;
    cin >> n >> m >> mg;
    // genereerime n unikaalse identifikaatoriga gruppi
    for (int i = 0; i < n; ++i) {
        int g;
        do { g = 1 + rand() % 1000; } while (grp.count(g) > 0);
        grp[g]; // "puudutame" grupi kirjet
        gg.push_back(g);
    }
    // genereerime igasse gruppi m liiget, neist mg grupid
    for (int i = 0; i < gg.size(); ++i) { // genereerime gg[i]
        for (int j = 0; j < mg; ++j) {
            int g;
            do { g = gg[rand() % gg.size()]; } while (grp[gg[i]].count(g) > 0);
            grp[gg[i]].insert(g);
        }
        for (int j = mg; j < m; ++j) {
            int u;
            do { u = 1 + rand() % 1000; } while (grp[gg[i]].count(-u) > 0);
            grp[gg[i]].insert(-u);
            uu.push_back(-u);
        }
    }
    // vljastame grupid genereerimise jrjekorras, see on niigi juhuslik
    cout << gg.size() << endl;
    for (int i = 0; i < gg.size(); ++i) {
        cout << gg[i] << " " << grp[gg[i]].size() << endl;
        // vljastame grupi liikmed juhuslikus jrjekorras
        vector<int> x(grp[gg[i]].begin(), grp[gg[i]].end());
        random_shuffle(x.begin(), x.end());
        for (int j = 0; j < x.size(); ++j) {
            if (j > 0)
                cout << " ";
            cout << x[j];
        }
        cout << endl;
    }
    // valime juhuslikult kasutaja, kelle kohta pring teha
    // valik eelistab kasutajaid, kes kuuluvad paljudesse gruppidesse
    random_shuffle(uu.begin(), uu.end());
    cout << uu[0] << endl;
    return 0;
}
