{ 2006-02-25 programmeerimisvistlus                                        }
{ lesanne: RISTKLIKU VRVIMINE                                            }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'rist.sis';                                    { sisendfaili nimi }
   valf = 'rist.val';                                   { vljundfaili nimi }

var
   f : text;
   x1, y1, x2, y2 : real;              { ristkliku kahe nurga koordinaadid }
   xa, xb, ya, yb : real;                  { sirge kahe punkti koordinaadid }
   v, p, a, u : boolean;                    { milliseid klgi sirge likab? }
   vy, py, ax, ux : real;          { likepunktide koordinaadid, kui likab }
   s1, s2 : real;                                          { osade pindalad }

begin
   { === loeme sisendandmed === }
   assign(f, sisf); reset(f);
   readln(f, x1, y1);
   readln(f, x2, y2);
   readln(f, xa, ya);
   readln(f, xb, yb);
   close(f);

   { === tuvastame sirge likumised ristkliku klgedega === }

   { kas sirge likab vasakut klge? }
   if xa = xb then
      v := false
   else begin
      vy := ya + (x1 - xa) * (yb - ya) / (xb - xa);
      v := not ((vy < y1) or (vy > y2));
   end;
   {writeln(v, ' ', vy :0:3);}

   { kas sirge likab paremat klge? }
   if xa = xb then
      p := false
   else begin
      py := ya + (x2 - xa) * (yb - ya) / (xb - xa);
      p := not ((py < y1) or (py > y2));
   end;
   {writeln(p, ' ', py :0:3);}

   { kas sirge likab alumist klge? }
   if ya = yb then
      a := false
   else begin
      ax := xa + (y1 - ya) * (xb - xa) / (yb - ya);
      a := not ((ax < x1) or (ax > x2));
   end;
   {writeln(a, ' ', ax :0:3);}

   { kas sirge likab lemist klge? }
   if ya = yb then
      u := false
   else begin
      ux := xa + (y2 - ya) * (xb - xa) / (yb - ya);
      u := not ((ux < x1) or (ux > x2));
   end;
   {writeln(u, ' ', ux :0:3);}

   { === leiame pindalad === }

   { "raligatud" osa }
   if v and p then begin
      { kui likab vasakut ja paremat klge, arvutame alumise trapetsi }
      s1 := (x2 - x1) * ((vy - y1) + (py - y1)) / 2;
      {writeln('VP ', s1 :0:3);}
   end else if a and u then begin
      { kui likab alumist ja lemist klge, arvutame vasaku trapetsi }
      s1 := (y2 - y1) * ((ax - x1) + (ux - x1)) / 2;
      {writeln('AU ', s1 :0:3);}
   end else if v and a then begin
      { kui likab vasakut ja alumist klge, arvutame kolmnurga }
      s1 := (ax - x1) * (vy - y1) / 2;
      {writeln('VA ', s1 :0:3);}
   end else if v and u then begin
      { kui likab vasakut ja lemist klge, arvutame kolmnurga }
      s1 := (ux - x1) * (y2 - vy) / 2;
      {writeln('VU ', s1 :0:3);}
   end else if p and a then begin
      { kui likab paremat ja alumist klge, arvutame kolmnurga }
      s1 := (x2 - ax) * (py - y1) / 2;
      {writeln('PA ', s1 :0:3);}
   end else if p and u then begin
      { kui likab paremat ja lemist klge, arvutame kolmnurga }
      s1 := (x2 - ux) * (y2 - py) / 2;
      {writeln('PU ', s1 :0:3);}
   end else begin
      writeln('Testi viga?');
      halt(1);
   end;

   { teine osa on terve ristklik miinus esimene }
   s2 := (x2 - x1) * (y2 - y1) - s1;
   {writeln(s2 :0:3);}

   { === vljastame vastuse === }
   assign(f, valf); rewrite(f);
   if s1 > s2 then begin
      writeln(f, s1 :0:3);
      writeln(f, s2 :0:3);
   end else begin
      writeln(f, s2 :0:3);
      writeln(f, s1 :0:3);
   end;
   close(f);
end.
