{Ulesanne: Detaili varvimine}
{Autor: Marina Issakova,}

program detail;

const
   sisf = 'rist.sis';  {sisendfaili nimi}
   valf = 'rist.val';  {valjundfaili nimi}

type punkt = record
     x, y: real;
     end;

var t: array[1..5] of punkt; {antud nelinurga punktide koordinaadid, esimene on kaks korda (ka viimaseks)}
    sx1, sy1, sx2, sy2: integer; {antud sirgjoone punktide koordinaadid}
    s1, s2: real; {osade pindala}

procedure loe_sisend;
var f: text;
begin
   assign(f,sisf);
   reset(f);
   readln(f,t[1].x,t[1].y);
   readln(f,t[3].x,t[3].y);
   t[2].x := t[3].x;
   t[2].y := t[1].y;
   t[4].x := t[1].x;
   t[4].y := t[3].y;
   readln(f,sx1,sy1);
   readln(f,sx2,sy2);
   close(f);
   t[5] := t[1];
end;

function min(x,y: real): real;
begin
   if x<=y then min := x
   else min := y;
end;

function max(x,y: real): real;
begin
   if x>=y then max := x
   else max := y;
end;

{sirgjoone ja nelinurga kulje poolt moodustatatud sirge loikepunkti
koordinaatide leidmine; vaartuseks on true, kui punkt asub nelinurga kulje peal}
function leia_punkt(a1,b1,a2,b2: real; var x: real; var y: real): boolean;
begin
   if ((a1-a2)*(sy2-sy1)-(sx1-sx2)*(b2-b1)) = 0 then
   begin
	leia_punkt:=false;
        exit;
   end;
   if (b2-b1<>0) and (sy2-sy1<>0) then
      begin
         y:= (-(a2*b1-a1*b2)*(sy2-sy1)+(sx2*sy1-sx1*sy2)*(b2-b1))/
             ((a1-a2)*(sy2-sy1)-(sx1-sx2)*(b2-b1));
         x:= (-y*(a1-a2)-(a2*b1-a1*b2))/(b2-b1);
      end;
   if (b2-b1=0) then
      begin
         y:= -(a2*b1-a1*b2)/(a1-a2);
         x:= (-y*(sx1-sx2)-(sx2*sy1-sx1*sy2))/(sy2-sy1);
      end;
   if (sy2-sy1=0) then
      begin
         y:= -(sx2*sy1-sx1*sy2)/(sx1-sx2);
         x:= (-y*(a1-a2)-(a2*b1-a1*b2))/(b2-b1);
      end;
   if (y>=min(b1,b2)) and (y<=max(b1,b2)) and
      (x>=min(a1,a2)) and (x<=max(a1,a2)) then
      leia_punkt := true
   else
      leia_punkt := false;
end;

{kolmnurga pindala leidmine}
function kolmnurga_pindala(a1,a2,a3: punkt): real;
begin
   kolmnurga_pindala := 0.5*abs(a1.x*a2.y-a3.x*a2.y-a1.x*a3.y-a2.x*a1.y
                      +a3.x*a1.y+a2.x*a3.y);
end;

{osade pindala leidmine}
procedure arvuta_pindala;
var s: real;
   t2: array[1..6] of punkt;
   t2i: integer;
   rist: boolean;
   i: integer;
   x, y: real;
begin
   s := kolmnurga_pindala(t[1],t[2],t[3]) + kolmnurga_pindala(t[3],t[4],t[5]);
   rist := false;
   t2i := 0;
   for i:=1 to 4 do
      begin
         if (not rist) then
            begin
               t2[t2i+1] := t[i];
               inc(t2i);
            end;
         if leia_punkt(t[i].x,t[i].y,t[i+1].x,t[i+1].y,x,y) then
            begin
               t2[t2i+1].x := x;
               t2[t2i+1].y := y;
               inc(t2i);
               if (x <> t[i+1].x) or (y <> t[i+1].y) then rist := not rist;
            end;
      end;
   s1 := 0;
   for i:= 1 to t2i-1 do
      begin
         s1 := s1 + kolmnurga_pindala(t2[1],t2[i],t2[i+1]);
      end;
   s2 := s - s1;
end;

procedure tee_valjund;
var f: text;
begin
   assign(f,valf);
   rewrite(f);
   if s1>s2 then
      begin
         writeln(f,s1:1:3);
         writeln(f,s2:1:3);
      end
   else
      begin
         writeln(f,s2:1:3);
         writeln(f,s1:1:3);
      end;
   close(f);
end;

begin
   loe_sisend;
   arvuta_pindala;
   tee_valjund;
end.
