{ 2006-02-25 programmeerimisvistlus                                        }
{ lesanne: KASUTAJAGRUPID                                                  }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'grp.sis';                                     { sisendfaili nimi }
   valf = 'grp.val';                                    { vljundfaili nimi }
   minid = -1000;                                   { minimaalne lubatud ID }
   maxid = 1000;                                   { maksimaalne lubatud ID }

var
   id : array [minid..maxid] of record             { identifikaatori andmed }
      n : integer;                          { mitmesse gruppi see ID kuulub }
      g : array [1..maxid] of integer;         { grupid, kuhu see ID kuulub }
      t : boolean;                                 { kas on juba tdeldud? }
   end;
   grp : array [1..maxid] of boolean;               { grupid, kuhu K kuulub }

{ lbib graafi sgavuti alates tipust t }
procedure tootle(t : integer);
var i : integer;
begin
   if id[t].t then                             { see tipp on juba tdeldud }
      exit;
   if t > 0 then                                           { kui t on grupp }
      grp[t] := true;                { mrgime, et K kuulub sellesse gruppi }
   id[t].t := true;                               { mrgime tipu tdelduks }
   for i := 1 to id[t].n do        { vaatleme tippe, millesse saame liikuda }
      tootle(id[t].g[i]);                                { ja ttleme need }
end;

var
   f : text;
   n, m, g, x, i, j, k : integer;

begin
   { algvrtustame }
   for i := minid to maxid do begin
      id[i].n := 0;
      id[i].t := false;
   end;
   for i := 1 to maxid do
      grp[i] := false;

   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, n);                                             { gruppide arv }
   for i := 1 to n do begin
      readln(f, g, m);                                 { grupi ID ja suurus }
      for j := 1 to m do begin
         read(f, x);                              { grupi jrjekordne liige }
         id[x].n := id[x].n + 1;
         id[x].g[id[x].n] := g;      { kasutaja vi grupp x kuulub gruppi g }
      end;
      readln(f);
   end;
   readln(f, k);                                         { uuritav kasutaja }

   { leiame vastuse graafi sgavuti lbimisega }
   tootle(k);

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   m := 0;
   for i := 1 to maxid do
      if grp[i] then
         m := m + 1;
   writeln(f, m);
   for i := 1 to maxid do
      if grp[i] then begin
         m := m - 1;
         if m > 0 then
            write(f, i, ' ')
         else
            writeln(f, i);
      end;
   close(f);
end.
