#include <stdio.h>
#include <math.h>

#define INFILE "neli.sis"
#define OFILE "neli.val"
#define HINT "neli.xxx"

void ERR() {
	printf("400 \n");
	exit(0);
}

main() {
	FILE *fi;
	FILE *out;
	FILE *hint;
	double n1,n2;
	int r1,r2;

	if ((fi = fopen(INFILE,"r")) == NULL) {
		ERR();
	}

	if ((hint  = fopen(HINT,"r")) == NULL) {
		ERR();
	}

	if ((out = fopen(OFILE,"r")) == NULL) {
		ERR();
	}

	for (;;) {
		r1 = fscanf(out,"%lf",&n1);
		r2 = fscanf(hint,"%lf",&n2);

		if ((r1!=1) && (r2!=1)) 
			break;
	
		if ((r1!=r2) || (isnan(n1)) || (fabs(n1-n2) > 0.0011) ) {
			printf("200 \n");
			printf("Score: 0\n");
			printf("Error: WRONG ANSWER\n");
			return 0;
		}
	}

	printf("200 \n");
	printf("Score: 100\n");
	printf("Error: OK\n");
	return 0;
}
