// 2006-02-25 programmeerimisvistlus
// lesanne: RNGASSRK
// Autor: Margus Niitsoo
// Testitud: GCC 3.2.3 / MinGW

// Servade jarjekorras labivaatus - kui kohatakse serva, mida pole veel maha
// tommatud, proovitakse seda eemaldada nii uhe kui teise otstipu eemaldamisega

#include <stdio.h>

int n;                  // Servade arv

int servad[3001][2];      // Servade loetelu
char tippmaas[101];     // Kas see tipp on juba maha voetud

int parim;              // Senini parim loigete arv
int loika[101];         // Loigatavad rongad
int praegu[101];        // Vaadeldava situatsiooni loiked

void otsi(int s, int cnt)
{
    int i;
    
    // Kui tombasime koik maha
    if (s>=n)
    {
        if (cnt<parim)
        {
            parim=cnt;
            for(i=0;i<cnt;i++)
                loika[i]=praegu[i];
        }

        return;
    }

    // Kontrolli, kas antud serv on juba maha tommatud
    if (tippmaas[servad[s][0]] || tippmaas[servad[s][1]])
        otsi(s+1,cnt);
    else if (cnt<parim-1)
    {
        // Proovi serva eemaldada, tommates maha uhe tema otspunkti
        tippmaas[servad[s][0]]=1;
        praegu[cnt]=servad[s][0];
        otsi(s+1,cnt+1);
        tippmaas[servad[s][0]]=0;
        
        tippmaas[servad[s][1]]=1;
        praegu[cnt]=servad[s][1];
        otsi(s+1,cnt+1);
        tippmaas[servad[s][1]]=0;
    }
 
    return;
}

int main(void)
{
    FILE * sis, *val;
    int i, a, b;
    
    // Algvaartusta muutujad
    for (i=1;i<101;i++)
        tippmaas[i]=0;

    // Loe sisend
    sis=fopen("rng.sis","rt");

    fscanf(sis,"%i",&n);

    for(i=0;i<n;i++)
    {
       fscanf(sis,"%i %i",&a,&b);
       servad[i][0]=a; servad[i][1]=b;
    }

    fclose(sis);

    parim=n+1;

    otsi(0,0);

    // Valjasta tulemus
    val=fopen("rng.val","wt");
    fprintf(val,"%i\n",parim);
    
    if (parim>0)
    {
        fprintf(val,"%i",loika[0]);
        for(i=1;i<parim;i++)
            fprintf(val," %i",loika[i]);
        fprintf(val,"\n");
    }
    
    fclose(val);

    return 0;
}
